
# (C) 2001-2012 Altera Corporation. All rights reserved.
# Your use of Altera Corporation's design tools, logic functions and 
# other software and tools, and its AMPP partner logic functions, and 
# any output files any of the foregoing (including device programming 
# or simulation files), and any associated documentation or information 
# are expressly subject to the terms and conditions of the Altera 
# Program License Subscription Agreement, Altera MegaCore Function 
# License Agreement, or other applicable license agreement, including, 
# without limitation, that your use is for the sole purpose of 
# programming logic devices manufactured by Altera and sold by Altera 
# or its authorized distributors. Please refer to the applicable 
# agreement for further details.

# ACDS 12.1 177 win32 2012.11.27.11:43:42

# ----------------------------------------
# Auto-generated simulation script

# ----------------------------------------
# Initialize the variable
if ![info exists SYSTEM_INSTANCE_NAME] { 
  set SYSTEM_INSTANCE_NAME ""
} elseif { ![ string match "" $SYSTEM_INSTANCE_NAME ] } { 
  set SYSTEM_INSTANCE_NAME "/$SYSTEM_INSTANCE_NAME"
} 

if ![info exists TOP_LEVEL_NAME] { 
  set TOP_LEVEL_NAME "pcie_standalone"
} elseif { ![ string match "" $TOP_LEVEL_NAME ] } { 
  set TOP_LEVEL_NAME "$TOP_LEVEL_NAME"
} 

if ![info exists QSYS_SIMDIR] { 
  set QSYS_SIMDIR "./../"
} elseif { ![ string match "" $QSYS_SIMDIR ] } { 
  set QSYS_SIMDIR "$QSYS_SIMDIR"
} 


# ----------------------------------------
# Copy ROM/RAM files to simulation directory

# ----------------------------------------
# Create compilation libraries
proc ensure_lib { lib } { if ![file isdirectory $lib] { vlib $lib } }
ensure_lib          ./libraries/     
ensure_lib          ./libraries/work/
vmap       work     ./libraries/work/
vmap       work_lib ./libraries/work/
if { ![ string match "*ModelSim ALTERA*" [ vsim -version ] ] } {
  ensure_lib                        ./libraries/altera_ver/            
  vmap       altera_ver             ./libraries/altera_ver/            
  ensure_lib                        ./libraries/lpm_ver/               
  vmap       lpm_ver                ./libraries/lpm_ver/               
  ensure_lib                        ./libraries/sgate_ver/             
  vmap       sgate_ver              ./libraries/sgate_ver/             
  ensure_lib                        ./libraries/altera_mf_ver/         
  vmap       altera_mf_ver          ./libraries/altera_mf_ver/         
  ensure_lib                        ./libraries/altera_lnsim_ver/      
  vmap       altera_lnsim_ver       ./libraries/altera_lnsim_ver/      
  ensure_lib                        ./libraries/cycloneiv_hssi_ver/    
  vmap       cycloneiv_hssi_ver     ./libraries/cycloneiv_hssi_ver/    
  ensure_lib                        ./libraries/cycloneiv_pcie_hip_ver/
  vmap       cycloneiv_pcie_hip_ver ./libraries/cycloneiv_pcie_hip_ver/
  ensure_lib                        ./libraries/cycloneiv_ver/         
  vmap       cycloneiv_ver          ./libraries/cycloneiv_ver/     
  ensure_lib 			    ./libraries/stratixiv_hssi_ver
  vmap	     stratixiv_hssi_ver	    ./libraries/stratixiv_hssi_ver
  ensure_lib			    ./libraries/stratixiv_ver
  vmap	     stratixiv_ver	    ./libraries/stratixiv_ver  
}
ensure_lib                                                                       ./libraries/pipe_interface_internal/                                              
vmap       pipe_interface_internal                                               ./libraries/pipe_interface_internal/                                              
ensure_lib                                                                       ./libraries/reset_controller_internal/                                            
vmap       reset_controller_internal                                             ./libraries/reset_controller_internal/                                            
ensure_lib                                                                       ./libraries/altgx_internal/                                                       
vmap       altgx_internal                                                        ./libraries/altgx_internal/                                                       
ensure_lib                                                                       ./libraries/pcie_internal_hip/                                                    
vmap       pcie_internal_hip                                                     ./libraries/pcie_internal_hip/                                                    
ensure_lib                                                                       ./libraries/width_adapter/                                                        
vmap       width_adapter                                                         ./libraries/width_adapter/                                                        
ensure_lib                                                                       ./libraries/rsp_xbar_mux/                                                         
vmap       rsp_xbar_mux                                                          ./libraries/rsp_xbar_mux/                                                         
ensure_lib                                                                       ./libraries/rsp_xbar_demux/                                                       
vmap       rsp_xbar_demux                                                        ./libraries/rsp_xbar_demux/                                                       
ensure_lib                                                                       ./libraries/cmd_xbar_demux/                                                       
vmap       cmd_xbar_demux                                                        ./libraries/cmd_xbar_demux/                                                       
ensure_lib                                                                       ./libraries/rst_controller/                                                       
vmap       rst_controller                                                        ./libraries/rst_controller/                                                       
ensure_lib                                                                       ./libraries/burst_adapter/                                                        
vmap       burst_adapter                                                         ./libraries/burst_adapter/                                                        
ensure_lib                                                                       ./libraries/limiter/                                                              
vmap       limiter                                                               ./libraries/limiter/                                                              
ensure_lib                                                                       ./libraries/id_router_001/                                                        
vmap       id_router_001                                                         ./libraries/id_router_001/                                                        
ensure_lib                                                                       ./libraries/id_router/                                                            
vmap       id_router                                                             ./libraries/id_router/                                                            
ensure_lib                                                                       ./libraries/addr_router/                                                          
vmap       addr_router                                                           ./libraries/addr_router/                                                          
ensure_lib                                                                       ./libraries/pcie_hard_ip_0_txs_translator_avalon_universal_slave_0_agent_rsp_fifo/
vmap       pcie_hard_ip_0_txs_translator_avalon_universal_slave_0_agent_rsp_fifo ./libraries/pcie_hard_ip_0_txs_translator_avalon_universal_slave_0_agent_rsp_fifo/
ensure_lib                                                                       ./libraries/pcie_hard_ip_0_txs_translator_avalon_universal_slave_0_agent/         
vmap       pcie_hard_ip_0_txs_translator_avalon_universal_slave_0_agent          ./libraries/pcie_hard_ip_0_txs_translator_avalon_universal_slave_0_agent/         
ensure_lib                                                                       ./libraries/pcie_hard_ip_0_bar2_translator_avalon_universal_master_0_agent/       
vmap       pcie_hard_ip_0_bar2_translator_avalon_universal_master_0_agent        ./libraries/pcie_hard_ip_0_bar2_translator_avalon_universal_master_0_agent/       
ensure_lib                                                                       ./libraries/pcie_hard_ip_0_txs_translator/                                        
vmap       pcie_hard_ip_0_txs_translator                                         ./libraries/pcie_hard_ip_0_txs_translator/                                        
ensure_lib                                                                       ./libraries/pcie_hard_ip_0_bar2_translator/                                       
vmap       pcie_hard_ip_0_bar2_translator                                        ./libraries/pcie_hard_ip_0_bar2_translator/                                       
ensure_lib                                                                       ./libraries/pcie_hard_ip_0/                                                       
vmap       pcie_hard_ip_0                                                        ./libraries/pcie_hard_ip_0/    
ensure_lib											./libraries/avalon_mm_bfm
vmap 	  avalon_mm_bfm										./libraries/avalon_mm_bfm
ensure_lib											./libraries/pcie_bfm
vmap	  pcie_bfm										./libraries/pcie_bfm

# ----------------------------------------
# Compile device library files
alias dev_com {
  echo "\[exec\] dev_com"
  if { ![ string match "*ModelSim ALTERA*" [ vsim -version ] ] } {
    vlog     "q:/acds/12.1/177/windows32/quartus/eda/sim_lib/altera_primitives.v"        -work altera_ver            
    vlog     "q:/acds/12.1/177/windows32/quartus/eda/sim_lib/220model.v"                 -work lpm_ver               
    vlog     "q:/acds/12.1/177/windows32/quartus/eda/sim_lib/sgate.v"                    -work sgate_ver             
    vlog     "q:/acds/12.1/177/windows32/quartus/eda/sim_lib/altera_mf.v"                -work altera_mf_ver         
    vlog -sv "q:/acds/12.1/177/windows32/quartus/eda/sim_lib/altera_lnsim.sv"            -work altera_lnsim_ver      
    vlog     "q:/acds/12.1/177/windows32/quartus/eda/sim_lib/cycloneiv_hssi_atoms.v"     -work cycloneiv_hssi_ver    
    vlog     "q:/acds/12.1/177/windows32/quartus/eda/sim_lib/cycloneiv_pcie_hip_atoms.v" -work cycloneiv_pcie_hip_ver
    vlog     "q:/acds/12.1/177/windows32/quartus/eda/sim_lib/cycloneiv_atoms.v"          -work cycloneiv_ver  
    vlog     "q:/acds/12.1/177/windows32/quartus/eda/sim_lib/stratixiv_atoms.v"          -work stratixiv_ver 
    vlog     "q:/acds/12.1/177/windows32/quartus/eda/sim_lib/stratixiv_hssi_atoms.v"          -work stratixiv_hssi_ver     
  }
}

# ----------------------------------------
# Compile the design files in correct order
alias com {
  echo "\[exec\] com"
  vlog     "$QSYS_SIMDIR/submodules/altpcie_pipe_interface.v"                               -work pipe_interface_internal                                              
  vlog     "$QSYS_SIMDIR/submodules/altpcie_pcie_reconfig_bridge.v"                         -work pipe_interface_internal                                              
  vlog     "$QSYS_SIMDIR/submodules/altera_pcie_hard_ip_reset_controller.v"                 -work reset_controller_internal                                            
  vlog     "$QSYS_SIMDIR/submodules/altpcie_rs_serdes.v"                                    -work reset_controller_internal                                            
  vlog     "$QSYS_SIMDIR/submodules/altpcie_pll_100_250.v"                                  -work reset_controller_internal                                            
  vlog     "$QSYS_SIMDIR/submodules/altpcie_pll_125_250.v"                                  -work reset_controller_internal                                            
  vlog     "$QSYS_SIMDIR/submodules/pcie_standalone_pcie_hard_ip_0_altgx_internal.vo"       -work altgx_internal                                                       
  vlog     "$QSYS_SIMDIR/submodules/mentor/avalon_stif/altpciexpav_stif_a2p_addrtrans.v"    -work pcie_internal_hip                                                    
  vlog     "$QSYS_SIMDIR/submodules/mentor/avalon_stif/altpciexpav_stif_a2p_fixtrans.v"     -work pcie_internal_hip                                                    
  vlog     "$QSYS_SIMDIR/submodules/mentor/avalon_stif/altpciexpav_stif_a2p_vartrans.v"     -work pcie_internal_hip                                                    
  vlog     "$QSYS_SIMDIR/submodules/mentor/avalon_stif/altpciexpav_stif_control_register.v" -work pcie_internal_hip                                                    
  vlog     "$QSYS_SIMDIR/submodules/mentor/avalon_stif/altpciexpav_stif_cr_avalon.v"        -work pcie_internal_hip                                                    
  vlog     "$QSYS_SIMDIR/submodules/mentor/avalon_stif/altpciexpav_stif_cr_interrupt.v"     -work pcie_internal_hip                                                    
  vlog     "$QSYS_SIMDIR/submodules/mentor/avalon_stif/altpciexpav_stif_cr_mailbox.v"       -work pcie_internal_hip                                                    
  vlog     "$QSYS_SIMDIR/submodules/mentor/avalon_stif/altpciexpav_stif_p2a_addrtrans.v"    -work pcie_internal_hip                                                    
  vlog     "$QSYS_SIMDIR/submodules/mentor/avalon_stif/altpciexpav_stif_reg_fifo.v"         -work pcie_internal_hip                                                    
  vlog     "$QSYS_SIMDIR/submodules/mentor/avalon_stif/altpciexpav_stif_rx.v"               -work pcie_internal_hip                                                    
  vlog     "$QSYS_SIMDIR/submodules/mentor/avalon_stif/altpciexpav_stif_rx_cntrl.v"         -work pcie_internal_hip                                                    
  vlog     "$QSYS_SIMDIR/submodules/mentor/avalon_stif/altpciexpav_stif_rx_resp.v"          -work pcie_internal_hip                                                    
  vlog     "$QSYS_SIMDIR/submodules/mentor/avalon_stif/altpciexpav_stif_tx.v"               -work pcie_internal_hip                                                    
  vlog     "$QSYS_SIMDIR/submodules/mentor/avalon_stif/altpciexpav_stif_tx_cntrl.v"         -work pcie_internal_hip                                                    
  vlog     "$QSYS_SIMDIR/submodules/mentor/avalon_stif/altpciexpav_stif_txavl_cntrl.v"      -work pcie_internal_hip                                                    
  vlog     "$QSYS_SIMDIR/submodules/mentor/avalon_stif/altpciexpav_stif_txresp_cntrl.v"     -work pcie_internal_hip                                                    
  vlog     "$QSYS_SIMDIR/submodules/mentor/avalon_stif/altpciexpav_clksync.v"               -work pcie_internal_hip                                                    
  vlog     "$QSYS_SIMDIR/submodules/mentor/avalon_lite/altpciexpav_lite_app.v"              -work pcie_internal_hip                                                    
  vlog     "$QSYS_SIMDIR/submodules/altpciexpav_stif_app.v"                                 -work pcie_internal_hip                                                    
  vlog     "$QSYS_SIMDIR/submodules/altpcie_hip_pipen1b_qsys.v"                             -work pcie_internal_hip                                                    
  vlog -sv "$QSYS_SIMDIR/submodules/altera_merlin_width_adapter.sv"                         -work width_adapter                                                        
  vlog -sv "$QSYS_SIMDIR/submodules/altera_merlin_burst_uncompressor.sv"                    -work width_adapter                                                        
  vlog -sv "$QSYS_SIMDIR/submodules/altera_merlin_address_alignment.sv"                     -work width_adapter                                                        
  vlog -sv "$QSYS_SIMDIR/submodules/altera_merlin_arbitrator.sv"                            -work rsp_xbar_mux                                                         
  vlog -sv "$QSYS_SIMDIR/submodules/pcie_standalone_rsp_xbar_mux.sv"                        -work rsp_xbar_mux                                                         
  vlog -sv "$QSYS_SIMDIR/submodules/pcie_standalone_rsp_xbar_demux.sv"                      -work rsp_xbar_demux                                                       
  vlog -sv "$QSYS_SIMDIR/submodules/pcie_standalone_cmd_xbar_demux.sv"                      -work cmd_xbar_demux                                                       
  vlog     "$QSYS_SIMDIR/submodules/altera_reset_controller.v"                              -work rst_controller                                                       
  vlog     "$QSYS_SIMDIR/submodules/altera_reset_synchronizer.v"                            -work rst_controller                                                       
  vlog -sv "$QSYS_SIMDIR/submodules/altera_merlin_burst_adapter.sv"                         -work burst_adapter                                                        
  vlog -sv "$QSYS_SIMDIR/submodules/altera_merlin_address_alignment.sv"                     -work burst_adapter                                                        
  vlog -sv "$QSYS_SIMDIR/submodules/altera_merlin_traffic_limiter.sv"                       -work limiter                                                              
  vlog     "$QSYS_SIMDIR/submodules/altera_avalon_st_pipeline_base.v"                       -work limiter                                                              
  vlog -sv "$QSYS_SIMDIR/submodules/pcie_standalone_id_router_001.sv"                       -work id_router_001                                                        
  vlog -sv "$QSYS_SIMDIR/submodules/pcie_standalone_id_router.sv"                           -work id_router                                                            
  vlog -sv "$QSYS_SIMDIR/submodules/pcie_standalone_addr_router.sv"                         -work addr_router                                                          
  vlog     "$QSYS_SIMDIR/submodules/altera_avalon_sc_fifo.v"                                -work pcie_hard_ip_0_txs_translator_avalon_universal_slave_0_agent_rsp_fifo
  vlog -sv "$QSYS_SIMDIR/submodules/altera_merlin_slave_agent.sv"                           -work pcie_hard_ip_0_txs_translator_avalon_universal_slave_0_agent         
  vlog -sv "$QSYS_SIMDIR/submodules/altera_merlin_burst_uncompressor.sv"                    -work pcie_hard_ip_0_txs_translator_avalon_universal_slave_0_agent         
  vlog -sv "$QSYS_SIMDIR/submodules/altera_merlin_master_agent.sv"                          -work pcie_hard_ip_0_bar2_translator_avalon_universal_master_0_agent       
  vlog -sv "$QSYS_SIMDIR/submodules/altera_merlin_slave_translator.sv"                      -work pcie_hard_ip_0_txs_translator                                        
  vlog -sv "$QSYS_SIMDIR/submodules/altera_merlin_master_translator.sv"                     -work pcie_hard_ip_0_bar2_translator                                       
  vlog     "$QSYS_SIMDIR/submodules/pcie_standalone_pcie_hard_ip_0.v"                       -work pcie_hard_ip_0                                                       

  
  vlog -sv "$QSYS_SIMDIR/submodules/verbosity_pkg.sv"					    -work avalon_mm_bfm
  vlog -sv "$QSYS_SIMDIR/submodules/avalon_mm_pkg.sv"					    -work avalon_mm_bfm
  vlog -sv -L avalon_mm_bfm "$QSYS_SIMDIR/submodules/altera_avalon_clock_source.sv"		-work avalon_mm_bfm
  vlog -sv -L avalon_mm_bfm "$QSYS_SIMDIR/submodules/altera_avalon_mm_slave_bfm.sv"		-work avalon_mm_bfm
  vlog -sv -L avalon_mm_bfm "$QSYS_SIMDIR/submodules/altera_conduit_bfm.sv"		-work avalon_mm_bfm
  vlog -sv -L avalon_mm_bfm "$QSYS_SIMDIR/submodules/altera_conduit_bfm_0002.sv"		-work avalon_mm_bfm
  vlog -sv -L avalon_mm_bfm "$QSYS_SIMDIR/submodules/altera_conduit_bfm_0003.sv"		-work avalon_mm_bfm
  vlog 	    "$QSYS_SIMDIR/submodules/altera_pcie_bfm_components.v"				-work pcie_bfm
  vlog 	   "$QSYS_SIMDIR/submodules/altera_pcie_bfm.v"						-work pcie_bfm
  vlog 	   "$QSYS_SIMDIR/submodules/altpcietb_bfm_driver.v"					-work pcie_bfm
  vlog     "$QSYS_SIMDIR/pcie_standalone.v"                                          
  vlog -sv "$QSYS_SIMDIR/pci_decoder.sv"
  vlog 	   "$QSYS_SIMDIR/pcie_standalone_tb.v"                                                               
}

# ----------------------------------------
# Elaborate top level design
alias elab {
  echo "\[exec\] elab"
  vsim -t ps -L work -L stratixiv_ver -L stratixiv_hssi_ver -L avalon_mm_bfm -L pcie_bfm -L work_lib -L pipe_interface_internal -L reset_controller_internal -L altgx_internal -L pcie_internal_hip -L width_adapter -L rsp_xbar_mux -L rsp_xbar_demux -L cmd_xbar_demux -L rst_controller -L burst_adapter -L limiter -L id_router_001 -L id_router -L addr_router -L pcie_hard_ip_0_txs_translator_avalon_universal_slave_0_agent_rsp_fifo -L pcie_hard_ip_0_txs_translator_avalon_universal_slave_0_agent -L pcie_hard_ip_0_bar2_translator_avalon_universal_master_0_agent -L pcie_hard_ip_0_txs_translator -L pcie_hard_ip_0_bar2_translator -L pcie_hard_ip_0 -L altera_ver -L lpm_ver -L sgate_ver -L altera_mf_ver -L altera_lnsim_ver -L cycloneiv_hssi_ver -L cycloneiv_pcie_hip_ver -L cycloneiv_ver $TOP_LEVEL_NAME
}

# ----------------------------------------
# Elaborate the top level design with novopt option
alias elab_debug {
  echo "\[exec\] elab_debug"
  vsim -novopt -t ps -L work -L stratixiv_ver -L stratixiv_hssi_ver -L avalon_mm_bfm -L pcie_bfm -L work_lib -L pipe_interface_internal -L reset_controller_internal -L altgx_internal -L pcie_internal_hip -L width_adapter -L rsp_xbar_mux -L rsp_xbar_demux -L cmd_xbar_demux -L rst_controller -L burst_adapter -L limiter -L id_router_001 -L id_router -L addr_router -L pcie_hard_ip_0_txs_translator_avalon_universal_slave_0_agent_rsp_fifo -L pcie_hard_ip_0_txs_translator_avalon_universal_slave_0_agent -L pcie_hard_ip_0_bar2_translator_avalon_universal_master_0_agent -L pcie_hard_ip_0_txs_translator -L pcie_hard_ip_0_bar2_translator -L pcie_hard_ip_0 -L altera_ver -L lpm_ver -L sgate_ver -L altera_mf_ver -L altera_lnsim_ver -L cycloneiv_hssi_ver -L cycloneiv_pcie_hip_ver -L cycloneiv_ver $TOP_LEVEL_NAME
}

# ----------------------------------------
# Compile all the design files and elaborate the top level design
alias ld "
  dev_com
  com
  elab
"

# ----------------------------------------
# Compile all the design files and elaborate the top level design with -novopt
alias ld_debug "
  dev_com
  com
  elab_debug
"

# ----------------------------------------
# Print out user commmand line aliases
alias h {
  echo "List Of Command Line Aliases"
  echo
  echo "dev_com                       -- Compile device library files"
  echo
  echo "com                           -- Compile the design files in correct order"
  echo
  echo "elab                          -- Elaborate top level design"
  echo
  echo "elab_debug                    -- Elaborate the top level design with novopt option"
  echo
  echo "ld                            -- Compile all the design files and elaborate the top level design"
  echo
  echo "ld_debug                      -- Compile all the design files and elaborate the top level design with -novopt"
  echo
  echo 
  echo
  echo "List Of Variables"
  echo
  echo "TOP_LEVEL_NAME                -- Top level module name."
  echo
  echo "SYSTEM_INSTANCE_NAME          -- Instantiated system module name inside top level module."
  echo
  echo "QSYS_SIMDIR                   -- Qsys base simulation directory."
}
h
